/*                                     ___   ___               */
/*           ▄▄▄       ██▓     ██▓███  |\  \ |\  \             */
/*          ▒████▄    ▓██▒    ▓██░  ██▒\ \  \\_\  \            */
/*          ▒██  ▀█▄  ▒██░    ▓██░ ██▓▒ \ \______  \           */
/*          ░██▄▄▄▄██ ▒██░    ▒██▄█▓▒ ▒  \|_____|\  \          */
/*           ▓█   ▓██▒░██████▒▒██▒ ░  ░         \ \__\         */
/*           ▒▒   ▓▒█░░ ▒░▓  ░▒▓▒░ ░  ░          \|__|         */
/*            ▒   ▒▒ ░░ ░ ▒  ░░▒ ░                             */
/*         F a░a s▒e && ░S░c h░ä f e r  \                      */
/*                ░  ░    ░  ░            S o  2 0 1 9         */



/*
#ifdef WAREHOUSE
#define WAREHOUSE
*/



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ INCLUDE ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <stdlib.h>
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ INCLUDE ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ TYPEDEF ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
typedef struct {
    char * storage;
    size_t length;
    pthread_mutex_t p_index_l;
    size_t p_index;
    pthread_mutex_t c_index_l;
    size_t c_index;
    sem_t fillCount;
    sem_t emptyCount;
    size_t numbers_taken;
    pthread_mutex_t amountlock;
} warehouse_t;
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ TYPEDEF ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ DECLARATION ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
warehouse_t * warehouse_init(void * args);
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ DECLARATION ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/



//#endif
