/*                                     ___   ___               */
/*           ▄▄▄       ██▓     ██▓███  |\  \ |\  \             */
/*          ▒████▄    ▓██▒    ▓██░  ██▒\ \  \\_\  \            */
/*          ▒██  ▀█▄  ▒██░    ▓██░ ██▓▒ \ \______  \           */
/*          ░██▄▄▄▄██ ▒██░    ▒██▄█▓▒ ▒  \|_____|\  \          */
/*           ▓█   ▓██▒░██████▒▒██▒ ░  ░         \ \__\         */
/*           ▒▒   ▓▒█░░ ▒░▓  ░▒▓▒░ ░  ░          \|__|         */
/*            ▒   ▒▒ ░░ ░ ▒  ░░▒ ░                             */
/*         F a░a s▒e && ░S░c h░ä f e r  \                      */
/*                ░  ░    ░  ░            S o  2 0 1 9         */



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ INCLUDE ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
#include "world.h"
#include "warehouse.h"
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ INCLUDE ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/



/*▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄ IMPLEMENTATION ▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄*/
void * producer(void * args)
{
  warehouse_t* warehouse = (warehouse_t*)  args;
  int flag = 1;
  while (flag)
  {
    produceItem();
    putItemIntoBuffer(warehouse);
    printbuffer(warehouse->storage, warehouse->length);
  }
  return NULL;
}


void * consumer(void * args)
{
  warehouse_t* warehouse = (warehouse_t*)  args;
  setvbuf(stdout, NULL, _IOLBF, 0);
  int flag = 1;
  while (flag)
  {
    removeItemFromBuffer(warehouse);
    consumeItem();
    printbuffer(warehouse->storage, warehouse->length);
  }
  return NULL;
}


void produceItem()
{
  printf("produce Item\n");
}
void consumeItem()
{
  printf("consume Item\n");
}


void printbuffer(char * buf, size_t len)
{
  printf("[ ");
  for ( size_t i = 0; i < len; i++ )
  {
    printf("%c ", buf[i]);
  }
  printf("]\n");
}
/*▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀ IMPLEMENTATION ▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀▀*/
